/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2203 from the
 * contents of Util.xs. Do not edit this file, edit Util.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Util.xs"
/**********************************************************************
 * PostgreSQL::InServer::Util
 *
 * src/pl/plperl/Util.xs
 *
 * Defines plperl interfaces for general-purpose utilities.
 * This module is bootstrapped as soon as an interpreter is initialized.
 * Currently doesn't define a PACKAGE= so all subs are in main:: to avoid
 * the need for explicit importing.
 *
 **********************************************************************/

/* this must be first: */
#include "postgres.h"
#include "fmgr.h"
#include "utils/builtins.h"
#include "utils/bytea.h"       /* for byteain & byteaout */

/* Defined by Perl */
#undef _

/* perl stuff */
#define PG_NEED_PERL_XSUB_H
#include "plperl.h"
#include "plperl_helpers.h"


static text *
sv2text(SV *sv)
{
	char	   *str = sv2cstr(sv);
	text	   *text;

	text = cstring_to_text(str);
	pfree(str);
	return text;
}

#line 49 "Util.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 101 "Util.c"

XS(XS___aliased_constants); /* prototype to pass -Wmissing-prototypes */
XS(XS___aliased_constants)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 55 "Util.xs"
    /* uses the ALIAS value as the return value */
    RETVAL = ix;
#line 120 "Util.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS__elog); /* prototype to pass -Wmissing-prototypes */
XS(XS__elog)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "level, msg");
    {
	int	level = (int)SvIV(ST(0));
	SV *	msg = ST(1);
#line 66 "Util.xs"
        if (level > ERROR)      /* no PANIC allowed thanks */
            level = ERROR;
        if (level < DEBUG5)
            level = DEBUG5;
        plperl_util_elog(level, msg);
#line 146 "Util.c"
    }
    XSRETURN_EMPTY;
}


XS(XS__quote_literal); /* prototype to pass -Wmissing-prototypes */
XS(XS__quote_literal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
	SV *	RETVAL;
#line 76 "Util.xs"
    if (!sv || !SvOK(sv)) {
        RETVAL = &PL_sv_undef;
    }
    else {
        text *arg = sv2text(sv);
		text *quoted = DatumGetTextP(DirectFunctionCall1(quote_literal, PointerGetDatum(arg)));
		char *str;

		pfree(arg);
		str = text_to_cstring(quoted);
		RETVAL = cstr2sv(str);
		pfree(str);
    }
#line 179 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__quote_nullable); /* prototype to pass -Wmissing-prototypes */
XS(XS__quote_nullable)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
	SV *	RETVAL;
#line 96 "Util.xs"
    if (!sv || !SvOK(sv))
	{
        RETVAL = cstr2sv("NULL");
    }
    else
	{
        text *arg = sv2text(sv);
		text *quoted = DatumGetTextP(DirectFunctionCall1(quote_nullable, PointerGetDatum(arg)));
		char *str;

		pfree(arg);
		str = text_to_cstring(quoted);
		RETVAL = cstr2sv(str);
		pfree(str);
    }
#line 216 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__quote_ident); /* prototype to pass -Wmissing-prototypes */
XS(XS__quote_ident)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 118 "Util.xs"
        text *arg;
		text *quoted;
		char *str;
#line 240 "Util.c"
	SV *	RETVAL;
#line 122 "Util.xs"
        arg = sv2text(sv);
		quoted = DatumGetTextP(DirectFunctionCall1(quote_ident, PointerGetDatum(arg)));

		pfree(arg);
		str = text_to_cstring(quoted);
		RETVAL = cstr2sv(str);
		pfree(str);
#line 250 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__decode_bytea); /* prototype to pass -Wmissing-prototypes */
XS(XS__decode_bytea)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 136 "Util.xs"
        char *arg;
        text *ret;
#line 273 "Util.c"
	SV *	RETVAL;
#line 139 "Util.xs"
        arg = SvPVbyte_nolen(sv);
        ret = DatumGetTextP(DirectFunctionCall1(byteain, PointerGetDatum(arg)));
        /* not cstr2sv because this is raw bytes not utf8'able */
        RETVAL = newSVpvn(VARDATA(ret), (VARSIZE(ret) - VARHDRSZ));
#line 280 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__encode_bytea); /* prototype to pass -Wmissing-prototypes */
XS(XS__encode_bytea)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 150 "Util.xs"
        text *arg;
        char *ret;
		STRLEN len;
#line 304 "Util.c"
	SV *	RETVAL;
#line 154 "Util.xs"
        /* not sv2text because this is raw bytes not utf8'able */
        ret = SvPVbyte(sv, len);
		arg = cstring_to_text_with_len(ret, len);
        ret = DatumGetCString(DirectFunctionCall1(byteaout, PointerGetDatum(arg)));
        RETVAL = cstr2sv(ret);
#line 312 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__looks_like_number); /* prototype to pass -Wmissing-prototypes */
XS(XS__looks_like_number)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
	SV *	RETVAL;
#line 166 "Util.xs"
    if (!SvOK(sv))
        RETVAL = &PL_sv_undef;
    else if ( looks_like_number(sv) )
        RETVAL = &PL_sv_yes;
    else
        RETVAL = &PL_sv_no;
#line 340 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__encode_typed_literal); /* prototype to pass -Wmissing-prototypes */
XS(XS__encode_typed_literal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "sv, typname");
    {
	SV *	sv = ST(0);
	char *	typname = (char *)SvPV_nolen(ST(1));
#line 180 "Util.xs"
		char 	*outstr;
#line 363 "Util.c"
	SV *	RETVAL;
#line 182 "Util.xs"
		outstr = plperl_sv_to_literal(sv, typname);
		if (outstr == NULL)
			RETVAL = &PL_sv_undef;
		else
			RETVAL = cstr2sv(outstr);
#line 371 "Util.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_PostgreSQL__InServer__Util); /* prototype to pass -Wmissing-prototypes */
XS(boot_PostgreSQL__InServer__Util)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
        CV * cv ;

        cv = newXSproto_portable("_aliased_constants", XS___aliased_constants, file, "");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("ERROR", XS___aliased_constants, file, "");
        XSANY.any_i32 = ERROR ;
        cv = newXSproto_portable("INFO", XS___aliased_constants, file, "");
        XSANY.any_i32 = INFO ;
        cv = newXSproto_portable("DEBUG", XS___aliased_constants, file, "");
        XSANY.any_i32 = DEBUG2 ;
        cv = newXSproto_portable("WARNING", XS___aliased_constants, file, "");
        XSANY.any_i32 = WARNING ;
        cv = newXSproto_portable("NOTICE", XS___aliased_constants, file, "");
        XSANY.any_i32 = NOTICE ;
        cv = newXSproto_portable("LOG", XS___aliased_constants, file, "");
        XSANY.any_i32 = LOG ;
        (void)newXSproto_portable("elog", XS__elog, file, "$$");
        (void)newXSproto_portable("quote_literal", XS__quote_literal, file, "$");
        (void)newXSproto_portable("quote_nullable", XS__quote_nullable, file, "$");
        (void)newXSproto_portable("quote_ident", XS__quote_ident, file, "$");
        (void)newXSproto_portable("decode_bytea", XS__decode_bytea, file, "$");
        (void)newXSproto_portable("encode_bytea", XS__encode_bytea, file, "$");
        (void)newXSproto_portable("looks_like_number", XS__looks_like_number, file, "$");
        (void)newXSproto_portable("encode_typed_literal", XS__encode_typed_literal, file, "$$");
    }

    /* Initialisation Section */

#line 191 "Util.xs"
    items = 0;  /* avoid 'unused variable' warning */

#line 429 "Util.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

